Skip to main content Skip to footer

Pasting Images into FlexGrid in JavaScript

Images pasted inside of FlexGrid cells

Background:

FlexGrid has built-in clipboard support that handles text and numeric data when pasting. You can also capture the paste before it’s processed and handle it yourself, for example, to accept image data from the system clipboard and insert it into a cell.

Steps to Complete:

  1. Disable the grid’s built-in clipboard behavior so we can intercept paste events.
  2. Attach a paste DOM event handler to catch image paste data from the clipboard.
  3. Detect image files in the clipboard data and convert them to a displayable URL.
  4. Insert the image into the grid cell and render it using a cell template.

Getting Started:

Disable the grid’s built-in clipboard behavior so we can intercept paste events

By default, pressing Ctrl+V pastes plain text into the grid. We disable this behavior (autoClipboard = false) so we can manually inspect and handle clipboard content.

<div id="theGrid"></div>
<p id="pasteMessage"></p>
import * as wjcGrid from '@mescius/wijmo.grid';

const data = getData();

const grid = new wjcGrid.FlexGrid('#theGrid', {
  itemsSource: data,
  autoClipboard: false,
  columns: [
    { header: 'ID', binding: 'id' },
    { header: 'Name', binding: 'name' },
    { header: 'Photo', binding: 'image', width: 120 }
  ]
});

function getData() {
  return [
    { id: 1, name: 'Item 1', image: '' },
    { id: 2, name: 'Item 2', image: '' }
  ];
}
  • autoClipboard: false disables default text pasting.

 

Attach a paste DOM event handler to catch image paste data from the clipboard

We listen for the browser’s native paste event on the grid’s host element so we can inspect clipboard content.

grid.hostElement.addEventListener('paste', function (e) {
  if (!e.clipboardData) return;

  const items = Array.from(e.clipboardData.items);
  const imageItem = items.find(
    i => i.kind === 'file' && i.type.startsWith('image/')
  );

  if (imageItem) {
    e.preventDefault();

    const blob = imageItem.getAsFile();
    const reader = new FileReader();

    reader.onload = function () {
      const url = reader.result;
      insertImageIntoCell(url);
      document.getElementById('pasteMessage').textContent =
        'Image pasted successfully.';
    };

    reader.readAsDataURL(blob);
  }
});
  • We check clipboard items for image file types.
  • If an image exists, we stop the default paste behavior.
  • FileReader converts the blob to a Base64 URL for display.

 

Detect image files in the clipboard data and convert them to a displayable URL

Once we have the Base64 image URL, we write it into the currently selected row’s image field.

function insertImageIntoCell(imgUrl) {
  const sel = grid.selection;

  if (sel.row > -1 && sel.col > -1) {
    grid.setCellData(sel.row, 'image', imgUrl, true);
  }
}
  • grid.selection determines which cell is active.
  • setCellData() updates the data item and refreshes the UI.

 

Insert the image into the grid cell and render it using a cell template

We use the formatItem event to render an <img> element when the cell contains image data.

grid.formatItem.addHandler(function (s, e) {
  if (e.panel === s.cells && s.columns[e.col].binding === 'image') {
    const item = s.rows[e.row].dataItem;
    if (item.image) {
      e.cell.innerHTML =
        '<img src="' + item.image + '" style="max-width:100px;" />';
    }
  }
});
  • The handler runs whenever a cell is rendered.
  • If the column is bound to image, we insert an <img> element.
  • The Base64 URL stored in the data item becomes the image source.

 

With this JavaScript setup:

  • Users can press Ctrl+V while a grid cell is selected.
  • If the clipboard contains an image, it is inserted into the selected row.
  • The grid displays the pasted image directly inside the cell.
  • You can extend this solution to validate file size/type or upload images to a server instead of embedding Base64 data.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Pasting Images into FlexGrid in Angular

FlexGrid with image pasted inside

Background:

FlexGrid has built-in clipboard support that handles text and numeric data when pasting. You can also capture the paste before it’s processed and handle it yourself, for example, to accept image data from the system clipboard and insert it into a cell.

Steps to Complete:

  1. Disable the grid’s built-in clipboard behavior so we can intercept paste events.
  2. Attach a paste DOM event handler to catch image paste data from the clipboard.
  3. Detect image files in the clipboard data and convert them to a displayable URL.
  4. Insert the image into the grid cell (e.g., using grid.setCellData or a cell template).

Getting Started:

Disable the grid’s built-in clipboard behavior so we can intercept paste events

By default, pressing Ctrl+V pastes plain text into the grid. We turn this off (autoClipboard = false) so we can handle pasting manually. Then we attach a standard DOM paste event on the grid host.

<!-- app.component.html -->
<wj-flex-grid
  #grid
  [itemsSource]="data"
  [autoClipboard]="false"
  style="height: 400px; width: 100%;">
</wj-flex-grid>

<p *ngIf="pasteMessage">{{ pasteMessage }}</p>
// app.component.ts
import { Component, ViewChild, ElementRef, AfterViewInit } from '@angular/core';
import { FlexGrid } from '@mescius/wijmo.angular2.grid';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html'
})
export class AppComponent implements AfterViewInit {
  @ViewChild('grid', { static: true }) grid: FlexGrid;
  data = this.getData();
  pasteMessage: string | null = null;

  ngAfterViewInit() {
    // Listen for native paste events
    this.grid.hostElement.addEventListener('paste', this.onPaste.bind(this));
  }

  getData() {
    return [
      { id: 1, name: 'Item 1', image: '' },
      { id: 2, name: 'Item 2', image: '' }
    ];
  }
}

 

Attach a paste DOM event handler to catch image paste data from the clipboard

The browser clipboard API exposes e.clipboardData.items, which can contain files or text. If an image file is present (item.kind === 'file' && item.type.startsWith('image/')), we convert it to a Base64 URL and update the grid cell. Otherwise we let text fall through.

// app.component.ts (continued)
onPaste(e: ClipboardEvent) {
  if (!e.clipboardData) {
    return;
  }

  const items = Array.from(e.clipboardData.items);
  const imageItem = items.find(i => i.kind === 'file' && i.type.startsWith('image/'));

  if (imageItem) {
    e.preventDefault();

    const blob = (imageItem as any).getAsFile();
    const reader = new FileReader();

    reader.onload = () => {
      const url = reader.result as string;
      this.insertImageIntoCell(url);
      this.pasteMessage = 'Image pasted successfully.';
    };

    reader.readAsDataURL(blob);
  }
}

 

Detect image files in the clipboard data and convert them to a displayable URL

Once we get a base64 image URL, we write it into the grid’s data item. The simplest approach is to store the URL in a field (e.g., image) that’s bound to a custom cell template. Then the image appears in the cell.

// app.component.ts (continued)
insertImageIntoCell(imgUrl: string) {
  const grid = this.grid;
  const sel = grid.selection;

  if (sel.row > -1 && sel.col > -1) {
    // Assume the 'image' field exists on the data item
    grid.setCellData(sel.row, 'image', imgUrl, true);
  }
}

 

Insert the image into the grid cell (e.g., using grid.setCellData or a cell template)

A basic string URL doesn’t show a picture on its own; we use a cellTemplate to render an <img> tag. Binding names like 'image' refer to that cell’s data field:

<wj-flex-grid
  #grid
  [itemsSource]="data"
  [autoClipboard]="false"
  style="height: 400px; width: 100%;">
  <wj-flex-grid-column
    header="Photo"
    binding="image"
    [cellTemplate]="imageTemplate"
    width="120">
  </wj-flex-grid-column>
</wj-flex-grid>

<ng-template #imageTemplate let-item let-col="col">
  <img *ngIf="item[col.binding]" [src]="item[col.binding]" style="max-width: 100px;" />
</ng-template>

 

With this Angular setup:

  • Users can press Ctrl+V or invoke a paste action while a grid cell is selected.
  • If the clipboard contains an image, it’s inserted into the selected cell’s image field.
  • The bound cell template renders the pasted image.
  • You can extend this system to accept multiple images, validate file size/type, or prompt the user before insertion.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Pasting Images into FlexGrid in Vue

FlexGrid with images pasted inside cells

Background:

FlexGrid has built-in clipboard support that handles text and numeric data when pasting. You can also capture the paste before it’s processed and handle it yourself, for example, to accept image data from the system clipboard and insert it into a cell.

Steps to Complete:

  1. Disable the grid’s built-in clipboard behavior so we can intercept paste events.
  2. Attach a paste DOM event handler to catch image paste data from the clipboard.
  3. Detect image files in the clipboard data and convert them to a displayable URL.
  4. Insert the image into the grid cell and render it with a cell template.

Getting Started:

Disable the grid’s built-in clipboard behavior so we can intercept paste events

By default, pressing Ctrl+V pastes plain text into the grid. We disable this behavior (autoClipboard = false) so we can manually handle the paste event and inspect clipboard content.

<template>
  <wj-flex-grid
    ref="grid"
    :itemsSource="data"
    :autoClipboard="false"
    style="height: 400px; width: 100%;">
    
    <wj-flex-grid-column
      header="Photo"
      binding="image"
      width="120"
      :cellTemplate="imageTemplate">
    </wj-flex-grid-column>

  </wj-flex-grid>

  <p v-if="pasteMessage">{{ pasteMessage }}</p>
</template>
<script>
import { WjFlexGrid, WjFlexGridColumn } from '@mescius/wijmo.vue2.grid';

export default {
  components: { WjFlexGrid, WjFlexGridColumn },

  data() {
    return {
      data: this.getData(),
      pasteMessage: null
    };
  },

  mounted() {
    // Listen for native paste events on the grid host element
    this.$refs.grid.control.hostElement.addEventListener(
      'paste',
      this.onPaste
    );
  },

  methods: {
    getData() {
      return [
        { id: 1, name: 'Item 1', image: '' },
        { id: 2, name: 'Item 2', image: '' }
      ];
    }
  }
};
</script>
  • autoClipboard="false" disables default paste behavior.
  • We attach a native paste event listener after the component mounts.

 

Attach a paste DOM event handler to catch image paste data from the clipboard

The browser clipboard API provides access to pasted content. We inspect clipboardData.items to detect image files and convert them into a Base64 URL.

methods: {
  onPaste(e) {
    if (!e.clipboardData) return;

    const items = Array.from(e.clipboardData.items);
    const imageItem = items.find(
      i => i.kind === 'file' && i.type.startsWith('image/')
    );

    if (imageItem) {
      e.preventDefault();

      const blob = imageItem.getAsFile();
      const reader = new FileReader();

      reader.onload = () => {
        const url = reader.result;
        this.insertImageIntoCell(url);
        this.pasteMessage = 'Image pasted successfully.';
      };

      reader.readAsDataURL(blob);
    }
  },
  • If an image exists in the clipboard, we prevent default paste behavior.
  • FileReader converts the image blob to a Base64 data URL for display.

 

Detect image files in the clipboard data and convert them to a displayable URL

Once we have the image URL, we insert it into the currently selected grid cell using setCellData.

insertImageIntoCell(imgUrl) {
  const grid = this.$refs.grid.control;
  const sel = grid.selection;

  if (sel.row > -1 && sel.col > -1) {
    grid.setCellData(sel.row, 'image', imgUrl, true);
  }
}
  • We retrieve the grid control via this.$refs.grid.control.
  • We retrieve the grid control via this.$refs.grid.control.

 

Insert the image into the grid cell and render it with a cell template

The selected row determines which item receives the image.

computed: {
  imageTemplate() {
    return (ctx) => {
      return ctx.item.image
        ? `<img src="${ctx.item.image}" style="max-width:100px;" />`
        : '';
    };
  }
}
  • The template checks if the cell has an image value.
  • If present, it renders an <img> element inside the cell.

 

With this Vue setup:

  • Users can press Ctrl+V while a grid cell is selected.
  • If the clipboard contains an image, it is inserted into the selected row.
  • The grid displays the pasted image directly inside the cell.
  • You can extend this approach to validate image size, restrict file types, or upload to a server instead of embedding Base64 data.

Happy coding!

Andrew Peterson

Technical Engagement Engineer